(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     14339,        426]
NotebookOptionsPosition[     11917,        358]
NotebookOutlinePosition[     12261,        373]
CellTagsIndexPosition[     12218,        370]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"Max", "@", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Length", "[", "i", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{"First", "@", 
       RowBox[{"PermutationCycles", "[", 
        RowBox[{"RandomSample", "[", "a", "]"}], "]"}]}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.75283736862609*^9, 3.752837392915208*^9}, {
  3.7528375362559805`*^9, 3.752837537215432*^9}, {3.752837616375268*^9, 
  3.752837649971011*^9}, {3.7528376852589684`*^9, 3.7528377582232656`*^9}, {
  3.7528377951161795`*^9, 
  3.752837810753623*^9}},ExpressionUUID->"fac15866-1199-4cf9-9eac-\
461dbe26f4d7"],

Cell[BoxData["50"], "Output",
 CellChangeTimes->{
  3.7528373756880507`*^9, 3.7528375388774695`*^9, {3.752837620429346*^9, 
   3.752837644402193*^9}, {3.752837688811905*^9, 3.7528377594055767`*^9}, {
   3.752837799346326*^9, 
   3.75283781309828*^9}},ExpressionUUID->"eb58d13c-5b76-445a-84ef-\
943df3db9f74"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"nb_", ",", "ns_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"pr", "=", "0"}], "}"}], ",", 
    RowBox[{
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"count", " ", "=", " ", "0"}], ",", 
       RowBox[{"count", "<", "ns"}], ",", " ", 
       RowBox[{"count", "++"}], ",", " ", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Max", "@", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Length", "[", "i", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", 
               RowBox[{"First", "@", 
                RowBox[{"PermutationCycles", "[", 
                 RowBox[{"RandomSample", "[", 
                  RowBox[{"Table", "[", 
                   RowBox[{"i", ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", "nb"}], "}"}]}], "]"}], "]"}],
                  "]"}]}]}], "}"}]}], "]"}]}], ">", 
          RowBox[{"nb", "/", "2"}]}], ",", 
         RowBox[{"pr", "++"}]}], "]"}]}], "]"}], ";", 
     RowBox[{"pr", "/", "ns"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7528393740530453`*^9, 
  3.752839450563317*^9}},ExpressionUUID->"c249e74d-311b-4778-b493-\
6b34adc3166c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", 
  RowBox[{"100", ",", "200"}], "]"}]], "Input",
 CellChangeTimes->{{3.7528393986779623`*^9, 3.7528394016792474`*^9}, {
  3.7528394565229015`*^9, 
  3.752839457623274*^9}},ExpressionUUID->"581a450c-37e4-4539-b5d9-\
792cc87eb06b"],

Cell[BoxData[
 FractionBox["7", "10"]], "Output",
 CellChangeTimes->{
  3.7528394582389193`*^9},ExpressionUUID->"3b09b34a-3462-4260-a2cd-\
279f1931283f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{"n", ",", "ns"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "10", ",", "200", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7528394739859514`*^9, 
  3.752839507088006*^9}},ExpressionUUID->"1629dd59-ca73-4452-8c7d-\
c5cc42dc90be"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["327", "500"], ",", 
   FractionBox["6679", "10000"], ",", 
   FractionBox["1353", "2000"], ",", 
   FractionBox["3397", "5000"], ",", 
   FractionBox["171", "250"], ",", 
   FractionBox["6821", "10000"], ",", 
   FractionBox["3451", "5000"], ",", 
   FractionBox["433", "625"], ",", 
   FractionBox["3421", "5000"], ",", 
   FractionBox["1381", "2000"], ",", 
   FractionBox["1361", "2000"], ",", 
   FractionBox["1741", "2500"], ",", 
   FractionBox["6897", "10000"], ",", 
   FractionBox["3483", "5000"], ",", 
   FractionBox["277", "400"], ",", 
   FractionBox["6883", "10000"], ",", 
   FractionBox["6951", "10000"], ",", 
   FractionBox["6851", "10000"], ",", 
   FractionBox["3443", "5000"], ",", 
   FractionBox["857", "1250"]}], "}"}]], "Output",
 CellChangeTimes->{
  3.75283951270879*^9},ExpressionUUID->"af995912-d1a5-4b7b-930f-3a7b5c9508b1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox["327", "500"], ",", 
     FractionBox["6679", "10000"], ",", 
     FractionBox["1353", "2000"], ",", 
     FractionBox["3397", "5000"], ",", 
     FractionBox["171", "250"], ",", 
     FractionBox["6821", "10000"], ",", 
     FractionBox["3451", "5000"], ",", 
     FractionBox["433", "625"], ",", 
     FractionBox["3421", "5000"], ",", 
     FractionBox["1381", "2000"], ",", 
     FractionBox["1361", "2000"], ",", 
     FractionBox["1741", "2500"], ",", 
     FractionBox["6897", "10000"], ",", 
     FractionBox["3483", "5000"], ",", 
     FractionBox["277", "400"], ",", 
     FractionBox["6883", "10000"], ",", 
     FractionBox["6951", "10000"], ",", 
     FractionBox["6851", "10000"], ",", 
     FractionBox["3443", "5000"], ",", 
     FractionBox["857", "1250"]}], "}"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7528395232467976`*^9, 3.752839529995908*^9}},
 NumberMarks->False,ExpressionUUID->"ab66e6e4-1b29-4bdb-ae13-1faf79aab4d1"],

Cell[BoxData[
 GraphicsBox[{{}, {{{}, {}, {
      {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       0.012833333333333334`], AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQAWIQDQEf7BU3FGVMfPvEHirg8PST/KX8+KdQPofDzXPf
gx8vhfEFHMoezBFcuhfGF3EQByuA8SUc/B2EEw9fhvFlHG7Gl/nLiT2D8hUc
zqddfZ6lDeMrOdzu+pv6/QlMvYpDfdaekskSMHk1B91Nc98vPwaT13CY/Ux2
+QsPmLyWQ95ixj2sQjC+jkP8DB/RHi8YX89BM6b/0FcNGN/AQfD4rh29bDC+
oYNC8rsoJzsY38jh3KrzV8PewOwzdth+keEeEydM3sTBIt0lM//DU3sAY95g
Tw==
        "]]}}}}, {}, {}, {{}, {}}, {{}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0., 0.6518700000000001},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0., 20.}, {0.654, 0.6966}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.752839517234204*^9, 
  3.752839531344156*^9}},ExpressionUUID->"7da53fd0-1d53-49a2-ad61-\
b30cdd6c931b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ns", "=", "10000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nb", "=", "100"}], ";", 
  RowBox[{"pr", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"prList", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"nb", "=", "10"}], ",", 
   RowBox[{"nb", "<", "20"}], ",", 
   RowBox[{"nb", "++"}], ",", " ", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"count", " ", "=", " ", "0"}], ",", 
      RowBox[{"count", "<", "ns"}], ",", " ", 
      RowBox[{"count", "++"}], ",", " ", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Max", "@", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Length", "[", "i", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"First", "@", 
               RowBox[{"PermutationCycles", "[", 
                RowBox[{"RandomSample", "[", 
                 RowBox[{"Table", "[", 
                  RowBox[{"i", ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", "nb"}], "}"}]}], "]"}], "]"}],
                 "]"}]}]}], "}"}]}], "]"}]}], ">", 
         RowBox[{"nb", "/", "2"}]}], ",", 
        RowBox[{"pr", "++"}]}], "]"}]}], "]"}], ";", 
    RowBox[{"Append", "[", 
     RowBox[{"prList", ",", 
      RowBox[{"pr", "/", "ns"}]}], "]"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pr", "/", "ns"}], "//", "N"}]}], "Input",
 CellChangeTimes->{{3.752837816065585*^9, 3.752837961887274*^9}, {
   3.752837993872992*^9, 3.752838079940792*^9}, {3.752838542252487*^9, 
   3.752838556491381*^9}, 3.752838741355724*^9, {3.752838802789611*^9, 
   3.7528388353440065`*^9}, {3.7528388746125317`*^9, 3.752838904201629*^9}, {
   3.752838975880684*^9, 3.7528389987445855`*^9}, {3.7528390699019227`*^9, 
   3.752839200302344*^9}, 
   3.752839253325038*^9},ExpressionUUID->"0c5adc60-caba-4018-bdba-\
3fba777c46ea"],

Cell[BoxData["6.9143`"], "Output",
 CellChangeTimes->{{3.7528380601310906`*^9, 3.7528380853527174`*^9}, {
   3.7528387749764757`*^9, 3.752838836270444*^9}, {3.7528388762875724`*^9, 
   3.752838905195053*^9}, {3.752838976971034*^9, 3.752838999390214*^9}, 
   3.7528390718528185`*^9, 
   3.7528392560455*^9},ExpressionUUID->"f8dd76d8-3e49-4c98-be96-6e6988a9af2e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["prList"], "Input",ExpressionUUID->"c0fe89b3-1ea3-4c93-afe3-42fa44c3521a"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{
  3.7528392691839714`*^9},ExpressionUUID->"9180f8f3-b075-4f9d-85f4-\
762ca210b4ef"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"N", "[", 
  RowBox[{
   FractionBox["pr", "ns"], ",", "200"}], "]"}]], "Input",
 CellChangeTimes->{{3.7528388290395803`*^9, 3.75283883002102*^9}},
 NumberMarks->False,ExpressionUUID->"899689d5-18de-4931-a7f7-85620e9dcf6b"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.7528388238295555`*^9, 
  3.7528388309714746`*^9}},ExpressionUUID->"5c6fc431-a70d-4bb2-bee3-\
49aa9df241d8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NumberForm", "[", 
  RowBox[{"0.`", ",", "32"}], "]"}]], "Input",
 CellChangeTimes->{{3.752838810453233*^9, 3.752838812287163*^9}},
 NumberMarks->False,ExpressionUUID->"620a5921-ba58-476c-b2be-3bd657408ea2"],

Cell[BoxData[
 TagBox[
  InterpretationBox["\<\"0.\"\>",
   0.,
   AutoDelete->True],
  NumberForm[#, 32]& ]], "Output",
 CellChangeTimes->{{3.752838806085718*^9, 
  3.7528388127199044`*^9}},ExpressionUUID->"5f96b502-60e7-4927-be91-\
29424fbf50de"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"Length", "[", "i", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", 
     RowBox[{"First", "@", 
      RowBox[{"PermutationCycles", "@", 
       RowBox[{"RandomSample", "@", 
        RowBox[{"Table", "[", 
         RowBox[{"i", ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", "100"}], "}"}]}], "]"}]}]}]}]}], 
    "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7528381343736815`*^9, 3.75283817960583*^9}, {
  3.7528384050009413`*^9, 
  3.752838421445545*^9}},ExpressionUUID->"b8aec11c-37c0-49c7-a46e-\
c2ec960fbb9e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6", ",", "24", ",", "3", ",", "60", ",", "2", ",", "3"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.7528381394128*^9, 3.7528381883238473`*^9}, 
   3.7528384399309688`*^9},ExpressionUUID->"80cc7380-2aac-447b-8056-\
46f50f059f86"]
}, Open  ]]
},
WindowSize->{1280, 637},
WindowMargins->{{-8, Automatic}, {Automatic, -8}},
FrontEndVersion->"11.1 for Microsoft Windows (64-bit) (March 13, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 648, 16, 30, "Input", "ExpressionUUID" -> \
"fac15866-1199-4cf9-9eac-461dbe26f4d7"],
Cell[1231, 40, 308, 6, 30, "Output", "ExpressionUUID" -> \
"eb58d13c-5b76-445a-84ef-943df3db9f74"]
}, Open  ]],
Cell[1554, 49, 1312, 36, 108, "Input", "ExpressionUUID" -> \
"c249e74d-311b-4778-b493-6b34adc3166c"],
Cell[CellGroupData[{
Cell[2891, 89, 262, 6, 30, "Input", "ExpressionUUID" -> \
"581a450c-37e4-4539-b5d9-792cc87eb06b"],
Cell[3156, 97, 153, 4, 44, "Output", "ExpressionUUID" -> \
"3b09b34a-3462-4260-a2cd-279f1931283f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3346, 106, 337, 9, 30, "Input", "ExpressionUUID" -> \
"1629dd59-ca73-4452-8c7d-c5cc42dc90be"],
Cell[3686, 117, 909, 24, 53, "Output", "ExpressionUUID" -> \
"af995912-d1a5-4b7b-930f-3a7b5c9508b1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4632, 146, 1092, 27, 85, "Input", "ExpressionUUID" -> \
"ab66e6e4-1b29-4bdb-ae13-1faf79aab4d1"],
Cell[5727, 175, 1611, 42, 242, "Output", "ExpressionUUID" -> \
"7da53fd0-1d53-49a2-ad61-b30cdd6c931b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7375, 222, 2012, 51, 145, "Input", "ExpressionUUID" -> \
"0c5adc60-caba-4018-bdba-3fba777c46ea"],
Cell[9390, 275, 361, 5, 30, "Output", "ExpressionUUID" -> \
"f8dd76d8-3e49-4c98-be96-6e6988a9af2e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9788, 285, 87, 0, 30, "Input", "ExpressionUUID" -> \
"c0fe89b3-1ea3-4c93-afe3-42fa44c3521a"],
Cell[9878, 287, 149, 4, 30, "Output", "ExpressionUUID" -> \
"9180f8f3-b075-4f9d-85f4-762ca210b4ef"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10064, 296, 246, 5, 51, "Input", "ExpressionUUID" -> \
"899689d5-18de-4931-a7f7-85620e9dcf6b"],
Cell[10313, 303, 158, 3, 30, "Output", "ExpressionUUID" -> \
"5c6fc431-a70d-4bb2-bee3-49aa9df241d8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10508, 311, 231, 4, 30, "Input", "ExpressionUUID" -> \
"620a5921-ba58-476c-b2be-3bd657408ea2"],
Cell[10742, 317, 248, 8, 44, "Output", "ExpressionUUID" -> \
"5f96b502-60e7-4927-be91-29424fbf50de"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11027, 330, 602, 17, 30, "Input", "ExpressionUUID" -> \
"b8aec11c-37c0-49c7-a46e-c2ec960fbb9e"],
Cell[11632, 349, 269, 6, 30, "Output", "ExpressionUUID" -> \
"80cc7380-2aac-447b-8056-46f50f059f86"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

